#ifndef FIRE_H
#define FIRE_H

/* This class was implemented due to the problems of passing the 
 * CProxy_IH323Events template class to MyH323EndPoint class.
 *
 * So instead we pass the reference of this nice simple class.
 * The CH323 big mother of an ATL class inherits this and implements
 * the virtual methods to call the template class methods.
 *
 * If anyone knows how to pass a reference to CProxy_IH323Events directly,
 * please implement it.
 */

class VBFire
{
public:
	VBFire() {};
	virtual void fire_Connected(BSTR RemoteUserName) {};
	virtual void fire_Disconnected(BSTR RemoteUserName) {};
	virtual void fire_RemoteUserInput(BSTR InputStr) {};
	virtual void fire_ReceivedCall(BSTR RemoteUserName) {};
	virtual void fire_RemoteRinging() {};
	virtual void fire_Error(SHORT Err, BSTR Error) {};
	virtual BSTR a2BSTR(LPCSTR lp) { return OLESTR(""); };
};


#endif